#! /bin/sh

usage() {
  echo ""
  echo "-------------------------------------------------------------------"
#	echo Usage: "$0" \<startup speed\> \<fpr\> \<serial number\>
	echo Usage: "$0" \<startup speed\> \<serial number\>
	echo "Startup speed can be 'fast' or 'slow'."
	echo " fast : The clock will not check for a modem."
	echo " slow : The clock will check whether a modem is attached on startup."
#	echo "Set fpr to configure fingerprint reader"
#	echo " -    : None"
#	echo " f    : Futronix reader"
#	echo " l    : Lumidigm reader"
  echo "-------------------------------------------------------------------"
	echo ""
	exit 1
}

if [ $# != 2 ]
then
	usage
fi

if [[ "$1" == "fast" || "$1" == "slow" ]]
then
	echo "Modem value is valid"
else
	usage
fi

if [[ $2 =~ ^[0-9]* ]] && [[ $2 -gt 0 ]];
then
	echo "Serial number is an integer"
else
	usage
fi

echo ""
echo " ----- Setting up Clock ----- "
echo ""

# Get the USB drive ready
echo " Formatting USB drive"
/usr/local/bin/formatusb.sh -detect

while [ $(pidof /usr/local/bin/formatusb.sh) ]
do
	sleep 1
done

# Set the time
echo "Setting the time"
/usr/local/bin/csrdate -v time.nist.gov
sleep 4

echo " Detect big flash init"
/usr/local/bin/dbf.sh usb

while [ ! -e "/var/local/data/capeclock.db" ]
do
	sleep 1
done

# Set serial number
echo Setting serial to "$2"
#/usr/local/bin/setserial.sh "$3"
echo "$2" > /var/local/data/SerialNumber.txt
echo "$2" > /var/sdcard/data/SerialNumber.txt
hostname CSTC$2
echo "CSTC$2" > /etc/hostname
/etc/init.d/samba restart

# Set up fast or slow start up
if [[ $1 == "fast" ]]
then
	/usr/local/bin/sqlite3shell /var/local/data/capeclock.db "update thisdev set modem = 2 where id  = 1;"
fi

if [[ $1 == "slow" ]]
then
	/usr/local/bin/sqlite3shell /var/local/data/capeclock.db "update thisdev set modem = 0 where id  = 1;"
fi

echo ""
echo " ----- Done ----- "
echo ""

echo ""
echo " ----- Summary ----- "
echo ""
echo "Modem setting:"
/usr/local/bin/sqlite3shell /var/local/data/capeclock.db "select modem from thisdev where id  = 1;"
echo "Serial:"
cat /var/local/data/SerialNumber.txt
echo ""
echo " ------------------- "
echo ""

sleep 2
/usr/local/bin/updateclock
if [ $? -eq 1 ]
then
	echo "No updates so we are going to start the clock"
	/usr/local/bin/startclock
elif [ $? -ne 0 ]
then
	echo "There was an error updating the clock. Starting the clock now."
	/usr/local/bin/startclock
fi

exit 0
